#include <amsmathutil25/amsmathutil25.hpp>

namespace ams
{
namespace rand
{

amsmu_randt1 dpr32_rseed;
amsmu_randt2 dpr64_rseed;

amsmu_randt1 dpr32_nextseed(amsmu_randt1 seed)
{
    amsmu_randt1 sret = seed;
    sret = ams::mod(sret*dpr32_mult1+dpr32_add1,dpr32_mod);
    return sret;
}

amsmu_randt2 dpr64_nextseed(amsmu_randt2 seed)
{
    amsmu_randt2 sret = seed;
    sret = ams::mod(sret*dpr64_mult1+dpr64_add1,dpr64_mod);
    return sret;
}




};
};